searchNodes=[{"doc":"Defines the data and functions used to style non-geom line elements.CSS presentation attributes: :color sets value of CSS stroke :size sets value of CSS stroke-width","ref":"GGity.Element.Line.html","title":"GGity.Element.Line","type":"module"},{"doc":"Constructor for a Line element.Setting the value of an attributed to nil will remove that property from the generated stylesheet altogether.Calling element_line(attributes) is equivalent to struct(GGity.Element.Line, attributes).","ref":"GGity.Element.Line.html#element_line/1","title":"GGity.Element.Line.element_line/1","type":"function"},{"doc":"","ref":"GGity.Element.Line.html#t:t/0","title":"GGity.Element.Line.t/0","type":"type"},{"doc":"Defines the data and functions used to style non-geom rect elements.CSS presentation attributes: :fill sets value of CSS fill :color sets value of CSS stroke :size sets value of CSS stroke-widthOther attributes: :height sets value of SVG height (height of the key glyph box)","ref":"GGity.Element.Rect.html","title":"GGity.Element.Rect","type":"module"},{"doc":"Constructor for a Rect element.Setting the value of an attributed to nil will remove that property from the generated stylesheet altogether.Calling element_rect(attributes) is equivalent to struct(GGity.Element.Line, attributes).","ref":"GGity.Element.Rect.html#element_rect/1","title":"GGity.Element.Rect.element_rect/1","type":"function"},{"doc":"","ref":"GGity.Element.Rect.html#t:t/0","title":"GGity.Element.Rect.t/0","type":"type"},{"doc":"Defines the data and functions used to style non-geom text elements.CSS presentation attributes: :family sets value of CSS font-family :face sets value of CSS font-face :color sets value of CSS fill :size sets value of CSS font-sizeOther attributes: :angle sets the value passed to transform: rotate() for the purpose of rotating x axis tick labels (has no effect when set for other theme elements)","ref":"GGity.Element.Text.html","title":"GGity.Element.Text","type":"module"},{"doc":"Constructor for a Text element.Setting the value of an attributed to nil will remove that property from the generated stylesheet altogether.Calling element_text(attributes) is equivalent to struct(GGity.Element.Line, attributes).","ref":"GGity.Element.Text.html#element_text/1","title":"GGity.Element.Text.element_text/1","type":"function"},{"doc":"","ref":"GGity.Element.Text.html#t:t/0","title":"GGity.Element.Text.t/0","type":"type"},{"doc":"Common functions for transforming axis tick labels.Break (i.e. axis tick or legend item) labels are formatted based on a scale's :labels option. This option can be provided in several forms:nil - No labels are drawn:waivers - drawn using the default formatting (Kernel.to_string/1)a function that takes a single argument representing the break value and returns a binaryan atom, representing the name of a built-in formatting function (e.g., commas/1)Note that the built-in formatting functions are not intended to be robust. One option for finely-tuned formatting would be to pass functions from the Cldr family of packages (must be added as a separate dependency).Examplesdata |&gt; Plot.new(%{x: &quot;x&quot;, y: &quot;y&quot;}) |&gt; Plot.geom_point() |&gt; Plot.scale_x_continuous(labels: nil) # value 1000 is printed as an empty stringdata |&gt; Plot.new(%{x: &quot;x&quot;, y: &quot;y&quot;}) |&gt; Plot.geom_point() |&gt; Plot.scale_x_continuous() # This is equivalant to Plot.scale_x_continuous(labels: :waivers) # value 1000 (integer) is printed as &quot;1000&quot; # value 1000.0 (float) is printed as &quot;1.0e3&quot; data |&gt; Plot.new(%{x: &quot;x&quot;, y: &quot;y&quot;, c: &quot;color&quot;}) |&gt; Plot.geom_point() |&gt; Plot.scale_color_viridis(labels: fn value -&gt; value &lt;&gt; &quot;!&quot; end) # value &quot;First Item&quot; is printed as &quot;First Item!&quot;data |&gt; Plot.new(%{x: &quot;x&quot;, y: &quot;y&quot;}) |&gt; Plot.geom_point() |&gt; Plot.scale_x_continuous(labels: :commas) # value 1000 (integer) is printed as &quot;1,000&quot; # value 1000 (float) is printed as &quot;1,000&quot;Date scales (e.g., GGity.Scale.X.Date) are a special case. For those scales, if a value for :date_labels has been specified, that pattern overrides any value for the :labels option. See GGity.Plot.scale_x_date/2 for more information regarding date labels.","ref":"GGity.Labels.html","title":"GGity.Labels","type":"module"},{"doc":"Applies a comma separator to a number and converts it to a string.If the number is a float, it is first rounded using Kernel.to_string/1.Note that simple floating point arithmetic is used; the various issues/errors associated with floating point values apply.iex&gt; GGity.Labels.commas(5000.0) &quot;5,000&quot; iex&gt; GGity.Labels.commas(1000.6) &quot;1,001&quot; iex&gt; GGity.Labels.commas(100.0) &quot;100&quot; iex&gt; GGity.Labels.commas(10_000_000) &quot;10,000,000&quot;","ref":"GGity.Labels.html#commas/1","title":"GGity.Labels.commas/1","type":"function"},{"doc":"Formats a number in U.S. dollars and cents.If the value is greater than or equal to 100,000 rounds to the nearest dollar and does not display cents.Note that simple floating point arithmetic is used; the various issues/errors associated with floating point values apply.iex&gt; GGity.Labels.dollar(5000.0) &quot;$5,000.00&quot; iex&gt; GGity.Labels.dollar(1000.6) &quot;$1,000.60&quot; iex&gt; GGity.Labels.dollar(100.0) &quot;$100.00&quot; iex&gt; GGity.Labels.dollar(10_000_000) &quot;$10,000,000&quot;","ref":"GGity.Labels.html#dollar/1","title":"GGity.Labels.dollar/1","type":"function"},{"doc":"Formats a number as a percent.Accepts a :precision option specifying the number of decimal places to be displayed.Note that simple floating point arithmetic is used; the various issues/errors associated with floating point values apply.iex&gt; GGity.Labels.percent(0.5) &quot;50%&quot; iex&gt; GGity.Labels.percent(0.111) &quot;11%&quot; iex&gt; GGity.Labels.percent(0.015, precision: 1) &quot;1.5%&quot; iex&gt; GGity.Labels.percent(10) &quot;1000%&quot;","ref":"GGity.Labels.html#percent/2","title":"GGity.Labels.percent/2","type":"function"},{"doc":"","ref":"GGity.Labels.html#t:tick_value/0","title":"GGity.Labels.tick_value/0","type":"type"},{"doc":"Configures and generates an iolist representing an SVG plot.The Plot module is GGity's public interface. A Plot struct is created with new/3, specifying the data and aesthetic mappings to be used, along with options associated with the plot's general appearance.Data must be provided as a list of maps, where each map in the list represents an observation, and the map's keys represent variable names. GGity does not perform any validation of the data; data is assumed to be clean and not to have missing values. Examples.mtcars() |&gt; Plot.new(%{x: :wt, y: :mpg})Mappings are specified using maps, where the map's keys are the names of supported aesthetics, and the values are the names of variables in the data. Examples.mtcars() |&gt; Plot.new(%{x: :wt, y: :mpg}) |&gt; Plot.geom_point()A plot layer (represented as a struct that implements the GGity.Geom protocol) is added to the plot using functions such as geom_point/3 or geom_line/3.As layers are assembled into a plot, the scales for each aesthetic are calculated using the data assigned to each aesthetic in each layer. Scales generate functions that transform data into an aesthetic value (e.g, an x coordinate or a color) and functions that transform an aesthetic value back into an observation (for the purpose of drawing axes or legends).The plot will assign default scales based on the type of data assigned to each aesthetic in each layer (by examining the value in the first row of the data), typically mapping numerical data to a continuous scale (if available) and binary data to a discrete scale. These assignments can be overridden by passing the Plot struct to a scale-setting function, e.g. scale_[scale_type]/2. For x values only, GGity will assign at date/datetime scale if the data mapped to the :x aesthetic is a Date, DateTime or NaiveDateTime struct. Examples.mtcars() |&gt; Plot.new(%{x: :wt, y: :mpg}) |&gt; Plot.geom_point() |&gt; Plot.plot()plot/1 generates an iolist that represents the plot. None of the data is sanitized, so users will need to be mindful of the risks of generating plots using user-supplied data or parameters.","ref":"GGity.Plot.html","title":"GGity.Plot","type":"module"},{"doc":"Adds a ribbon geom to the plot with the position: :stack option set.geom_area/3 is a convenience alias for geom_ribbon/3 that sets the :position option to :stack in order to create stacked area chart.See geom_ribbon/3 for available aesthetics and options.Note that stacked ribbon charts are not yet supported - mappings to the :y_min aesthetic will be ignored.","ref":"GGity.Plot.html#geom_area/3","title":"GGity.Plot.geom_area/3","type":"function"},{"doc":"Adds a bar geom to the plot.Accepts an alternative dataset to be used; if one is not provided defaults to the plot dataset.Accepts a mapping and/or additonal options to be used. The provided mapping is merged with the plot mapping for purposes of the geom - there is no need to re-specify the :x mapping.Bar geoms support mapping data to the following aesthetics, which use the noted default scales::x (required):y (required to draw the geom, but not typically specified for bar geoms - see below):alpha:fillBar geoms also support providing fixed values (specified as options, e.g. color: &quot;blue&quot;) for the optional aesthetics above. A fixed value is assigned to the aesthetic for all observations.geom_bar/3 uses the :count stat, which counts the number of observations in the data for each combination of mapped aesthetics and assigns that value to the :y aesthetic. To create a bar chart with bars tied values of a specific variable use specify stat: :identity or use geom_col/3, which is identical to calling geom_bar/3 with the stat: :identity option. In either case, if stat: :identity is called, a variable in the data must be mapped to the :y aesthetic.Other supported options::key_glyph - Type of glyph to use in the legend key. Available values are :a, :point, :path, :rect and :timeseries. Defaults to :rect.:position - Available values are::identity (bars sit on top of each other; not recommended),:stack (one bar per :x value):dodge (one bar per unique :x/:fill value pair). Defaults to :stack.:stat - an atom referring to a statistical transformation function in the GGity.Stat module that is to be applied to the data. Defaults to :count (see above).","ref":"GGity.Plot.html#geom_bar/3","title":"GGity.Plot.geom_bar/3","type":"function"},{"doc":"Shorthand for geom_bar(plot, stat: :identity).Produces a bar chart similar to geom_bar/3, but uses the values of observations mapped to the :y aesthetic (instead of observation counts) to calculate the height of the bars. See geom_bar/3 for supported options.","ref":"GGity.Plot.html#geom_col/3","title":"GGity.Plot.geom_col/3","type":"function"},{"doc":"Adds a line geom to the plot.Accepts an alternative dataset to be used; if one is not provided defaults to the plot dataset.Accepts a mapping and/or additonal options to be used. The provided mapping is merged with the plot mapping for purposes of the geom - there is no need to re-specify the :x or :y mappings.Note that the line geom sorts the data by the values for the variable mapped to the :x aesthetic using Erlang default term ordering.Line geoms support mapping data to the following aesthetics, which use the noted default scales::x (required):y (required):alpha:color:linetype:sizeLine geoms also support providing fixed values (specified as options, e.g. color: &quot;blue&quot;) for the optional aesthetics above. A fixed value is assigned to the aesthetic for all observations.Other supported options::key_glyph - Type of glyph to use in the legend key. Available values are :path and :timeseries. By default this value is assigned based on the type of the value in the first row of the data for the variable mapped to the :x aesthetic.","ref":"GGity.Plot.html#geom_line/3","title":"GGity.Plot.geom_line/3","type":"function"},{"doc":"Adds a layer with a point geom to the plot.Accepts an alternative dataset to be used; if one is not provided defaults to the plot dataset.Accepts a mapping and/or additonal options to be used. The provided mapping is merged with the plot mapping for purposes of the geom - there is no need to re-specify the :x or :y mappings.Point geoms support mapping data to the following aesthetics, which use the noted default scales::x (required):y (required):alpha:color:shape:sizePoint geoms also support providing fixed values (specified as options, e.g. color: &quot;blue&quot;) for the optional aesthetics above. A fixed value is assigned to the aesthetic for all observations.Other supported options::key_glyph - Type of glyph to use in the legend key. Available values are :point, :path and :timeseries; defaults to :point.:stat - an atom referring to a statistical transformation function in the GGity.Stat module that is to be applied to the data. Defaults to :identity (i.e., no transformation).","ref":"GGity.Plot.html#geom_point/3","title":"GGity.Plot.geom_point/3","type":"function"},{"doc":"Adds a ribbon geom to the plot.Accepts an alternative dataset to be used; if one is not provided defaults to the plot dataset.Accepts a mapping and/or additonal options to be used. The provided mapping is merged with the plot mapping for purposes of the geom - there is no need to re-specify the :x mapping.Ribbon geoms support mapping data to the following aesthetics, which use the noted default scales::x (required):y_max (required) - defines the top boundary of the ribbon:y_min - defines the bottom boundary of the ribbon; defaults to zero:alpha:fillA ribbon geom with no :y_min specified is essentially an area chart. To draw a stacked area chart, set the :position option to :stack, or use the geom_area/3 convenience function.Ribbon geoms also support providing fixed values (specified as options, e.g. fill: &quot;blue&quot;) for the :alpha and :fill aesthetics above. A fixed value is assigned to the aesthetic for all observations. Fixed values can also be specified for::color - ribbon border color:size - ribbon border color widthOther supported options::key_glyph - Type of glyph to use in the legend key. Available values are :a, :point, :path, :rect and :timeseries. Defaults to :rect.:position - Available values are::identity (ribbons overlay one another),:stack (ribbons stacked on the y-axis; note ) Defaults to :identity.Note that stacked ribbon charts are not yet supported - mappings to the :y_min aesthetic will be ignored is :positon is set to :stack.","ref":"GGity.Plot.html#geom_ribbon/3","title":"GGity.Plot.geom_ribbon/3","type":"function"},{"doc":"Adds a layer with a text geom to the plot.Accepts an alternative dataset to be used; if one is not provided defaults to the plot dataset.A common use for text geoms is labelling of bar or point geoms. For bar chart labels in particular, it is important to specify the same stat and postion adjustment for the text geom as that specified for the bar chart.Accepts a mapping and/or additonal options to be used. The provided mapping is merged with the plot mapping for purposes of the geom - there is no need to re-specify the :x or :y mappings.Text geoms support mapping data to the following aesthetics, which use the noted default scales::x (required):y (required):label (required - the text to be displayed):group:alpha:color:sizeThe :group aesthetic is generally needed for bar chart labelling, where the :fill or :alpha aesthetic is mapped to a value in the data, in those scenarios, the text geom position adjustment must match the bar, and the :group aesthetic for the text geom should be mapped to the variable mapped to :fill or :alpha on the bar chart layer. See the visual examples code for examples.Text geoms also support providing fixed values (specified as options, e.g. color: &quot;blue&quot;) for the optional aesthetics above. A fixed value is assigned to the aesthetic for all observations.Other supported options::family - The font family used to display the text; equivalent to the SVG font-family attribute. Defaults to &quot;Helvetica, Arial, sans-serif&quot;.:fontface - Equivalent to SVG font-weight attribute. Defaults to :normal.:hjust - Horizontal alignment of the text relevant to element's :x value. Valid values are :left, :center and :right. Defaults to :center.:key_glyph - Type of glyph to use in the legend key. Available values are :a, :point, :path and :timeseries. Defaults to :a.nudge_x, :nudge_y - Adjust the x- or y-position value by the specified number of pixels. Both default to 0.:position - Available values are :identity (no adjustment), :stack (:y value represents cumulative value for a given :x value) or :dodge (one text element per unique pair of :x and other non-:y mapped aesthetics). Defaults to :identity.position_vjust - Adjust :y position vertically; expressed as a percentage of the calculated :y value after taking into account the specified position adjustment. Defaults to 1.:stat - an atom referring to a statistical transformation function in the GGity.Stat module that is to be applied to the data. Defaults to :identity (i.e., no transformation). Supported values are :count and :identity. Where text geom is intended to serve as a label for another layer with the :count stat, the state for the text layer should:vjust - Baseline of the text relevant to element's :y value. Valid values are :top, :middle and :bottom. Defaults to :center.","ref":"GGity.Plot.html#geom_text/3","title":"GGity.Plot.geom_text/3","type":"function"},{"doc":"Manually sets the type of guide used for specified scales.Accepts a keyword list of aesthetics and values for the :guide options for the associated scales.Currently this is only used to turn legends on or off. Valid values are :legend (draw a legend) and :none (do not draw a legend).ExamplePlot.new(%{x: &quot;x&quot;, y: &quot;y&quot;}) |&gt; Plot.geom_point(color: &quot;color&quot;, shape: &quot;shape&quot;, size: &quot;size&quot;) # By default all three legends will be drawn |&gt; Plot.guides(shape: :none, size: :none) # Plot will only draw a legend for the color scale","ref":"GGity.Plot.html#guides/2","title":"GGity.Plot.guides/2","type":"function"},{"doc":"Updates plot title, axis and legend labels.Accepts a keyword list where the keys are :title and/or the aesthetic(s) tied to the axes/legends to be labelled.","ref":"GGity.Plot.html#labs/2","title":"GGity.Plot.labs/2","type":"function"},{"doc":"Generates a Plot struct with provided data and aesthetic mappings.data must be passed in the form of a list of maps, where each map represents an observation or record, the map keys are variable names, and the map values represent the measurement of that variable for that observation.integer()Mappings tie variables to aesthetics, i.e. visual characteristics of the plot. A mapping is specified using a map, with key-value pairs representing the assignment of variables to available aesthetics. Mappings passed to new/3 must include key-value pairs for the :x aesthetic and the :y aesthetic.new/3 also supports several options that shortcut plot creation or alter the appearance of the plot. All graphical size units are in pixels.:area_padding - amount of blank space before the first tick and after the last tick on each axis (same value applied to both axes) defaults to 10.:aspect_ratio - the ratio of the plot area height to :width. Defaults to 1.5.:breaks - the number of tick intervals on the x- and y axis (same value applied to both axes). This may be adjusted by the scale function based on the data. Defaults to 5.:labels - a map specifying the titles of the plot (:title), x and y-axes (:x and :y) or legend title for another aesthetic (e.g. :color). A nil value indicates no label. Defaults to %{title: :nil, x: nil, y: nil}.:margins - a map with keys :left, :top, :right and :bottom, specifying the plot margins. Default is %{left: 30, top: 10, right: 0, bottom: 0}.:panel_background_color - a string value (hex or CSS color name) for the panel background. Defaults to grey (#eeeeee):y_label_padding - vertical distance between the y axis and its label. Defaults to 20.","ref":"GGity.Plot.html#new/3","title":"GGity.Plot.new/3","type":"function"},{"doc":"Generates an iolist of SVG markup representing a Plot.The data is not sanitized; users should be mindful of the risks of generating a plot with user-defined data and parameters.The Plot struct's :plot_width and :aspect_ratio values are used to set the height and width properties of the SVG. The viewBox property is set by the plot's :width and :aspect_ratio values.","ref":"GGity.Plot.html#plot/1","title":"GGity.Plot.plot/1","type":"function"},{"doc":"Sets geom point opacity for continuous data.This scale defines a mapping function that assigns an opacity to be mapped to a given value of the mapped variable.This function takes the following options::range - a tuple with minimum (default - 0.1) and maximum (default - 1) values to be bound to the data","ref":"GGity.Plot.html#scale_alpha_continuous/2","title":"GGity.Plot.scale_alpha_continuous/2","type":"function"},{"doc":"Sets geom point opacity for categorical data.For categorical data for which a linear mapping of values to opacity is not appropriate, this scale generates a palette of evenly spaced opacity values mapped to each unique value of the data. The palette is generated such that the difference between each opacity value is maximized. The set of unique data values are sorted for the purpose of assigning them to an opacity and ordering the legend.This function also takes the following options::labels - specifies how legend item names (levels of the scale) should be formatted. See GGity.Labels for valid values for this option.:range - a tuple with minimum (default - 0.1) and maximum (default - 1) values to be bound to the data","ref":"GGity.Plot.html#scale_alpha_discrete/2","title":"GGity.Plot.scale_alpha_discrete/2","type":"function"},{"doc":"Sets geom point opacity using the value of the data mapped to the :alpha aesthetic. Can be used to manually assign opacity to individual data points by including an value with each observation.See scale_color_identity/1 for an example of identity scale use.","ref":"GGity.Plot.html#scale_alpha_identity/1","title":"GGity.Plot.scale_alpha_identity/1","type":"function"},{"doc":"Sets geom point color using the value of the data mapped to the color aesthetic. Can be used to manually assign colors to individual data points by including a color value with each observation. Such color values must be provided as a hex value or CSS color name.For example, with the dataset below, one could render points for :weight values as &quot;blue&quot; for low weights and &quot;red&quot; for high weights by assigning a value to the :point_color variable accordingly.[ %{weight: 6, age: 4, point_color: &quot;blue&quot;}, %{weight: 5, age: 3, point_color: &quot;blue&quot;}, %{weight: 8, age: 4, point_color: &quot;red&quot;}, %{weight: 7, age: 4, point_color: &quot;red&quot;}, ] |&gt; Plot.new(%{x: :weight, y: :age}) |&gt; Plot.geom_point(%{color: :point_color}) |&gt; Plot.scale_color_identity() |&gt; Plot.plot","ref":"GGity.Plot.html#scale_color_identity/1","title":"GGity.Plot.scale_color_identity/1","type":"function"},{"doc":"Sets geom point colour using the Viridis color palettes. Viridis is used by ggplot2 and other libraries in part because it is optimized to maintain contrast when viewed by those with various types of color blindess.The scale is discrete - it is intended to map colors to categorical data. The scale generates a palette of evenly spaced values from the Viridis color palette and these are mapped to each unique value of the data. The palette is generated such that the visual difference between each color value is maximized. The set of unique data values are sorted for the purpose of assigning them to a color and ordering the legend.This function also takes the following options::labels - specifies how legend item names (levels of the data mapped to the scale) should be formatted. See GGity.Labels for valid values for this option.:option - specifies which palette to use. Available palettes are :magma, :inferno, :plasma, :viridis (the default) and :cividis. These palettes can also be specified via their letter codes - :a, :b, :c, :d and :e, respectively.Examples of each color palette option can be generated using mix ggity.visual.scale_color_viridis.","ref":"GGity.Plot.html#scale_color_viridis/2","title":"GGity.Plot.scale_color_viridis/2","type":"function"},{"doc":"Sets fill color for fillable shapes (e.g., bars).Accepts the same options as scale_color_viridis/2.","ref":"GGity.Plot.html#scale_fill_viridis/2","title":"GGity.Plot.scale_fill_viridis/2","type":"function"},{"doc":"","ref":"GGity.Plot.html#scale_label_identity/1","title":"GGity.Plot.scale_label_identity/1","type":"function"},{"doc":"Sets type of line for categorical data in line charts.This scale uses a palette of six line types (:solid, :dashed, :dotted, :longdash, :dotdash and :twodash) that are mapped to each unique value of the data. The set of unique data values are sorted for the purpose of assigning them to a line type (in the same order as listed above) and ordering the legend.If there are more than six unique values in the data, the line types are recycled per the order above.This function also takes the following options::labels - specifies how legend item names (levels of the scale) should be formatted. See GGity.Labels for valid values for this option.","ref":"GGity.Plot.html#scale_linetype_discrete/2","title":"GGity.Plot.scale_linetype_discrete/2","type":"function"},{"doc":"Sets geom point marker shape for categorical data.This scale uses a palette of four marker types (:circle, :square, :diamond and :triangle) that are mapped to each unique value of the data. The set of unique data values are sorted for the purpose of assigning them to a size (using the shape order above) and ordering the legend.If there are greater than four unique values in the data, the shapes are recycled per the order above.This function also takes the following options::labels - specifies how legend item names (levels of the scale) should be formatted. See GGity.Labels for valid values for this option.","ref":"GGity.Plot.html#scale_shape/2","title":"GGity.Plot.scale_shape/2","type":"function"},{"doc":"Sets geom point marker shape for categorical data using a custom palette.This scale requires a :values option be passed, which must contain a list of characters or valid shape names (:circle, :square, :diamond or :triangle) to be used as markers. These values are mapped to the unique values of the mapped variable in term order. The list must have as many values as there are unique values in the data.This function also takes the following (optional) options::labels - specifies how legend item names (levels of the scale) should be formatted. See GGity.Labels for valid values for this option.[ %{x: 6, y: 4, mood: &quot;happy&quot;}, %{x: 5, y: 3, mood: &quot;ok&quot;}, %{x: 8, y: 4, mood: &quot;sad&quot;}, %{x: 7, y: 4, mood: &quot;sad&quot;}, ] |&gt; Plot.new(%{x: :x, y: :y}) |&gt; Plot.geom_point(%{shape: :mood}, size: 7) |&gt; Plot.scale_shape_manual(values: [&quot;😀&quot;, &quot;😐&quot;, &quot;☹️&quot;]) |&gt; Plot.plot()","ref":"GGity.Plot.html#scale_shape_manual/2","title":"GGity.Plot.scale_shape_manual/2","type":"function"},{"doc":"Sets geom point size for continuous data.This scale defines a mapping function that assigns a shape area based on the given value of the mapped variable.This function takes the following options::range - a tuple with minimum (default - 9) and maximum (default - 100) values to be bound to the data","ref":"GGity.Plot.html#scale_size_continuous/2","title":"GGity.Plot.scale_size_continuous/2","type":"function"},{"doc":"Sets geom point size for categorical data.For categorical data for which a linear mapping of values to marker size is not appropriate, this scale generates a palette of evenly spaced area values between 9 and 100 that are mapped to each unique value of the data. The palette is generated such that the difference between each size value is maximized. The set of unique data values are sorted for the purpose of assigning them to a size and ordering the legend.This function also takes the following options::labels - specifies how legend item names (levels of the scale) should be formatted. See GGity.Labels for valid values for this option.:range - a tuple with minimum (default - 9) and maximum (default - 100) values to be bound to the data","ref":"GGity.Plot.html#scale_size_discrete/2","title":"GGity.Plot.scale_size_discrete/2","type":"function"},{"doc":"Sets geom point size using the value of the data mapped to the size aesthetic. Can be used to manually assign size to individual data points by including an value with each observation.Note that &quot;size&quot; is the marker diameter, not marker area (which is generally preferable but not yet implemented).See scale_color_identity/1 for an example of identity scale use.","ref":"GGity.Plot.html#scale_size_identity/1","title":"GGity.Plot.scale_size_identity/1","type":"function"},{"doc":"Sets geom x coordinate for continuous numerical data.This scale defines a mapping function that assigns a coordinate on the x axis to the value of the mapped variable. The scale also defines an inverse of this function that is used to generate axis tick labels.This function also takes the following options::labels - specifies how break names (tick labels calculated by the scale) should be formatted. See GGity.Labels for valid values for this option.","ref":"GGity.Plot.html#scale_x_continuous/2","title":"GGity.Plot.scale_x_continuous/2","type":"function"},{"doc":"Sets geom x coordinate for continuous Date data.This scale defines a mapping function that assigns a coordinate on the x axis to the value of the mapped variable. The scale also defines an inverse of this function that is used to generate axis tick labels.This function also takes the following options::labels - specifies how break names (tick labels calculated by the scale) should be formatted. See GGity.Labels for valid values for this option. -:date_labels - special formatting patterns for dates. If :date_labels is specified, the value of the :labels option will be overridden.:date_labels can be either a format string pattern that is accepted by NimbleStrftime: data |&gt; Plot.new(%{x: :date_variable, y: :other_variable}) |&gt; Plot.geom_line() |&gt; Plot.scale_x_date(date_labels: &quot;%b %d %Y&quot;) # Label format &quot;Jan 01 2001&quot;or a tuple {format, options} where format is the pattern and options is a keyword list of options accepted by NimbleStrftime.format/3: rename_weekdays = fn day_of_week -&gt; { &quot;Monday&quot;, &quot;Tuesday&quot;, &quot;Hump Day&quot;, &quot;Thursday&quot;, &quot;Friday&quot;, &quot;Saturday&quot;, &quot;Sunday&quot; } |&gt; elem(day_of_week - 1) end data |&gt; Plot.new(%{x: :date_variable, y: :other_variable}) |&gt; Plot.geom_line() |&gt; Plot.scale_x_date(date_labels: {&quot;%A&quot;, day_of_week_names: rename_weekdays}) # Ticks are just weekday names, Wednesday is Hump Day","ref":"GGity.Plot.html#scale_x_date/2","title":"GGity.Plot.scale_x_date/2","type":"function"},{"doc":"Sets geom x coordinate for continuous DateTime data.This scale defines a mapping function that assigns a coordinate on the x axis to the value of the mapped variable. The scale also defines an inverse of this function that is used to generate axis tick labels.This function also takes the following options::labels - specifies how break names (tick labels calculated by the scale) should be formatted. See GGity.Labels for valid values for this option. -:date_labels - special formatting patterns for dates. If :date_labels is specified, the value of the :labels option will be overridden.:date_labels can be either a format string pattern that is accepted by NimbleStrftime:See scale_x_date/2 for more usage examples. data |&gt; Plot.new(%{x: :datetime_variable, y: :other_variable}) |&gt; Plot.geom_line() |&gt; Plot.scale_x_datetime(date_labels: &quot;%b %d H%H&quot;) # Label format &quot;Jan 01 H01&quot;","ref":"GGity.Plot.html#scale_x_datetime/2","title":"GGity.Plot.scale_x_datetime/2","type":"function"},{"doc":"Sets geom x coordinate for discrete (categorical) data.This scale defines a mapping function that assigns a coordinate on the x axis to the value of the mapped variable. In the discrete case, this is equivalent to evenly distributing geoms across the x axis.This function also takes the following options::labels - specifies how break names (tick labels calculated by the scale) should be formatted. See GGity.Labels for valid values for this option.","ref":"GGity.Plot.html#scale_x_discrete/2","title":"GGity.Plot.scale_x_discrete/2","type":"function"},{"doc":"Sets geom y coordinate for continuous numerical data.This scale defines a mapping function that assigns a coordinate on the y axis to the value of the mapped variable. The scale also defines an inverse of this function that is used to generate axis tick labels.This function also takes the following options::labels - specifies how break names (tick labels calculated by the scale) should be formatted. See GGity.Labels for valid values for this option.","ref":"GGity.Plot.html#scale_y_continuous/2","title":"GGity.Plot.scale_y_continuous/2","type":"function"},{"doc":"Updates the plot theme.GGity uses themes to style non-data plot elements. The default theme is similar to ggplot2's signature gray background/white gridline theme.theme/2 is used to update on or more elements of the plot theme by passing a keyword list of new elements and values, which are merged with those of the current theme.For supported elements and values, see GGity.Theme.","ref":"GGity.Plot.html#theme/2","title":"GGity.Plot.theme/2","type":"function"},{"doc":"Saves the plot to a file at the given path.","ref":"GGity.Plot.html#to_file/2","title":"GGity.Plot.to_file/2","type":"function"},{"doc":"Updates the plot x axis label.","ref":"GGity.Plot.html#xlab/2","title":"GGity.Plot.xlab/2","type":"function"},{"doc":"Updates the plot y axis label.","ref":"GGity.Plot.html#ylab/2","title":"GGity.Plot.ylab/2","type":"function"},{"doc":"","ref":"GGity.Plot.html#t:column/0","title":"GGity.Plot.column/0","type":"type"},{"doc":"","ref":"GGity.Plot.html#t:mapping/0","title":"GGity.Plot.mapping/0","type":"type"},{"doc":"","ref":"GGity.Plot.html#t:name/0","title":"GGity.Plot.name/0","type":"type"},{"doc":"","ref":"GGity.Plot.html#t:options/0","title":"GGity.Plot.options/0","type":"type"},{"doc":"","ref":"GGity.Plot.html#t:record/0","title":"GGity.Plot.record/0","type":"type"},{"doc":"","ref":"GGity.Plot.html#t:t/0","title":"GGity.Plot.t/0","type":"type"},{"doc":"Themes store style and other attributes of non-geom elements of a plot.GGity generates an embedded stylesheet for the CSS presentation attributes of these elements that ties the specified styles to custom CSS classes that are automatically generated for each type of element.Classes are generated irrespective of theme values, thereby allowing for the use of external stylesheets. To avoid overriding a style in an external stylesheet, set the value of the attribute(s) styled externally to nil in a plot's theme - GGity will not include a style in the embedded stylesheet for an attribute with a nil value.Each key of a Theme struct represents a class. Allowed types for each item include:nil - no selector or styles are generated for that class%Element.Line{} struct - generates styles for a line element%Element.Rect{} struct - generates styles for a rect element%Element.Text{} struct - generates styles for a text elementAn integer - for non-CSS attributes of a given element, e.g., :axis_ticks_length, which sets the value of the length attributeSee the documentation for each element type for allowed keys and values. Keys conform to the ggplot2 API, which means that a given attribute does not necessarily correspond to the CSS attribute of the same name. For example, :size means CSS stroke-width for lines and rectangles, and CSS font-size for text.Element structs can be generated using the constructor function for that element type:import GGity.Element.Text alias GGity.Plot Plot.theme(plot, axis_text: element_text(color: &quot;green&quot;, size: 12)) #=&gt; equivalent to Plot.theme(plot, axis_text: %GGity.Element.Text{color: &quot;green&quot;, size 12})The following elements are supported::text style for all non-data text; overriden by other text attributes (Element.Text):axis_line x- and y axes lines (Element.Line):axis_line_x x axis; overrides :axis_line (Element.Line):axis_line_y y axis; overrides :axis_line (Element.Line):axis_text x- and y axis tick label text (Element.Text):axis_text_x x axis tick label text; overrides :axis_text (Element.Text):axis_text_y y axis tick label text; overrides :axis_text (Element.Text):axis_ticks x- and y axis ticks (Element.Line):axis_line_x x axis ticks; overrides :axis_ticks (Element.Line):axis_line_y y axis ticks; overrides :axis_ticks (Element.Line):axis_ticks_length length of x- and y axis ticks (Integer - non-CSS attribute):axis_ticks_x_length length of x axis tick; overrides :axis_tick_length (Integer):axis_ticks_y_length length of y axis tick; overrides :axis_tick_length (Integer):axis_title x- and y axis title text (Element.Text):axis_title_x x axis title text; overrides :axis_title (Element.Text):axis_title_y y axis title text; overrides :axis_title (Element.Text):legend_key legend key glyph box (Element.Rect):legend_text legend item text (Element.Text):legend_title legend title text (Element.Text):panel_background panel (area bounded by axes) background (Element.Rect):panel_border panel border (Element.Line):panel_grid minor and major gridlines (Element.Line):panel_grid_major major gridlines; overrides panel_grid (Element.Line):panel_grid_minor minor gridlines; overrides panel_grid (Element.Line):plot_title plot title text (Element.Text):plot_background plot (entire SVG element) background (Element.Rect)","ref":"GGity.Theme.html","title":"GGity.Theme","type":"module"},{"doc":"","ref":"GGity.Theme.html#t:t/0","title":"GGity.Theme.t/0","type":"type"},{"doc":"Launch a browser and display all sample pages.","ref":"Mix.Tasks.Ggity.Visual.html","title":"Mix.Tasks.Ggity.Visual","type":"task"},{"doc":"Launch a browser and draw sample bar geom plots.","ref":"Mix.Tasks.Ggity.Visual.Geom.Bar.html","title":"Mix.Tasks.Ggity.Visual.Geom.Bar","type":"task"},{"doc":"Launch a browser and draw sample line geom plots.","ref":"Mix.Tasks.Ggity.Visual.Geom.Line.html","title":"Mix.Tasks.Ggity.Visual.Geom.Line","type":"task"},{"doc":"Launch a browser and draw sample point geom plots.","ref":"Mix.Tasks.Ggity.Visual.Geom.Point.html","title":"Mix.Tasks.Ggity.Visual.Geom.Point","type":"task"},{"doc":"Launch a browser and draw sample area and ribbion geom plots.","ref":"Mix.Tasks.Ggity.Visual.Geom.Ribbon.html","title":"Mix.Tasks.Ggity.Visual.Geom.Ribbon","type":"task"},{"doc":"Launch a browser and draw sample text geom plots.","ref":"Mix.Tasks.Ggity.Visual.Geom.Text.html","title":"Mix.Tasks.Ggity.Visual.Geom.Text","type":"task"},{"doc":"Launch a browser and draw sample plots with more than one layer.","ref":"Mix.Tasks.Ggity.Visual.Layers.html","title":"Mix.Tasks.Ggity.Visual.Layers","type":"task"},{"doc":"Launch a browser and draw sample plots using the Viridis color scale.","ref":"Mix.Tasks.Ggity.Visual.Scale.Color.Viridis.html","title":"Mix.Tasks.Ggity.Visual.Scale.Color.Viridis","type":"task"},{"doc":"UPDATE - a website with usage examples is now up and running at: http://www.pocketbookvote.com.GGityGGity brings the familiar interface of R's ggplot2 library to SVG charting in Elixir.","ref":"readme.html","title":"GGity","type":"extras"},{"doc":"A GGity plot is constructed from data, a geom (such as points, bars or lines) and a mapping of aesthetics (x, y, color, size, etc.) to variables in the data.Data must be provided as a list of maps, where each map is an observation, and the map's keys are the names of the variables observed.The mapping is specified with a map containing key-value pairs of variable names and aesthetics. Mappings must be provided for the x and y aesthetics; other aesthetics are optional, with fixed default values applied if a mapping is not specified. See the documentation for supported aesthetics for each geom. Examples.mtcars() |&gt; Plot.new(%{x: :wt, y: :mpg}) |&gt; Plot.labs(title: &quot;Basic Plot&quot;, x: &quot;Weight (lbs)&quot;, y: &quot;Miles Per Gallon&quot;) |&gt; Plot.geom_point() |&gt; Plot.plot()Note that the library includes a few of R's canonical datasets, which are used in these examples and available to support development as described further below.Mappings can also be specified when a geom is added: Examples.mtcars() |&gt; Plot.new(%{x: :wt, y: :mpg}) |&gt; Plot.geom_point(%{shape: :cyl}) |&gt; Plot.labs(title: &quot;Shape Aesthetic&quot;, shape: &quot;Cylinders&quot;) |&gt; Plot.plot()Legends are currently only supported for discrete scales.Aesthetics can be assigned a fixed value (not tied to a variable), and both legend and axis labels support custom formatting. Examples.tx_housing() |&gt; Enum.filter(fn record -&gt; record[&quot;city&quot;] in [&quot;Houston&quot;, &quot;Fort Worth&quot;, &quot;San Antonio&quot;, &quot;Dallas&quot;, &quot;Austin&quot;] end) |&gt; Plot.new(%{x: &quot;sales&quot;, y: &quot;median&quot;}) |&gt; Plot.labs(title: &quot;Custom labels, fixed alpha&quot;) |&gt; Plot.geom_point(%{color: &quot;city&quot;}, alpha: 0.4) |&gt; Plot.scale_x_continuous(labels: :commas) |&gt; Plot.scale_y_continuous(labels: fn value -&gt; &quot;$\#{Labels.commas(round(value / 1000))}K&quot; end) |&gt; Plot.scale_color_viridis(option: :magma, labels: fn value -&gt; &quot;\#{value}!!!&quot; end) |&gt; Plot.plot()Line geoms support mapping discrete variables to color or line type. Examples.economics_long() |&gt; Plot.new(%{x: &quot;date&quot;, y: &quot;value01&quot;}) |&gt; Plot.labs(title: &quot;Mapped to color&quot;) |&gt; Plot.geom_line(%{color: &quot;variable&quot;}) |&gt; Plot.plot()Bar charts are also supported. By default they display stacked counts of observations (as shown below), but they can also display grouped bars (position = &quot;dodge&quot; in ggplot2 parlance) as well as raw y values (geom_col). Examples.mpg() |&gt; Enum.filter(fn record -&gt; record[&quot;manufacturer&quot;] in [&quot;chevrolet&quot;, &quot;audi&quot;, &quot;ford&quot;, &quot;nissan&quot;, &quot;subaru&quot;] end) |&gt; Plot.new(%{x: &quot;manufacturer&quot;}) |&gt; Plot.geom_bar(%{fill: &quot;class&quot;}) |&gt; Plot.scale_fill_viridis(option: :inferno) |&gt; Plot.plot()","ref":"readme.html#examples","title":"GGity - Examples","type":"extras"},{"doc":"I am interested in data visualization and after learning a lot from the work being done on ContEx, I decided that starting to write a basic clone of ggplot2 would help me learn more about the grammar of graphics, ggplot2 and how to develop a reasonably nontrivial library for Elixir.","ref":"readme.html#goals","title":"GGity - Goals","type":"extras"},{"doc":"Meet a real-world need - I code as a hobby, so this is not the product of a real-world use case. There are probably edge cases unaddressed and validations that should be happening, but for now they are harder to find because I am not using this in the wild.Optimize for performance pre-emptively - Because I am not using this in a real world application, performance is not as critical or (more importantly) apparent to me, so my focus tends to be on new features.","ref":"readme.html#non-goals","title":"GGity - Non-Goals","type":"extras"},{"doc":"ContEx - is more widely used, has some special LiveView features, Gantt charts and (very cool) sparklines. It is also guided by grammar of graphics concepts but is not as dogmatic about it as this library will be.Plotex - focused on time series. Dates/times are hard, and while I have not looked at it in detail I bet Plotex does them better than GGity.","ref":"readme.html#alternatives","title":"GGity - Alternatives","type":"extras"},{"doc":"RoadmapGGity has a roadmap which is subject to change based on what is interesting to me, how difficult those items turn out to be to implement and issues/ideas/contribution from others.Visual testsGGity has decent unit test coverage, but given the domain, a picture is worth a thousand words. Therefore the library includes some mix tasks that generate plots of the included datasets to support development. I have used them on Ubuntu Linux and WSL on Windows.Linux examples:mix ggity.visual.geom.point # Generates a file with point geom examples and opens in Firefox. mix ggity.visual.geom.line google-chrome # Generates a file with line geom examples and opens in Chrome. # Any browser can be specified using the binary name that would launch it # from the terminal; Firefox is the default if nothing is specified. mix ggity.visual # Generates all of the example files and opens them in Firefox. # Each file is opened in sequence and the next file launches when # the preceding browser instance is closed.WSL example:mix ggity.visual.geom.point --wsl # The --wsl option works for WSL users by generating a file with # point geom examples and opening the file in Firefox in Windows # assuming Firefox is installed in the default location. # If a browser window is already opened, each example will open a new tab; # otherwise the behavior is the same as in Linux. # The --wsl option doesn't support other browsers on Windows at this time.Other checksThe library also includes an alias (mix checks) that runs Credo, Dialyzer, the visual tests and formatter in sequence. I prefer to have all of those things in order before committing a change.","ref":"readme.html#development","title":"GGity - Development","type":"extras"},{"doc":"I am very grateful to @mindok, the author of ContEx, who graciously accepted and provided feedback on contributions to that library, which in turn inspired me to write this (and flat out copy some a few parts of ContEx in so doing). I do not view GGity as a replacement for ContEx; it is a personal opportunity for me to learn a lot at my own pace. I made it public in case it might be helpful to others as an example.Acknowledgement is also due to Hadley Wickham and others who have built ggplot2; the library is great, but Wickham's grammar of graphics is really an excellent piece of academic work in its own right. Along with Edward Tufte's book I think it is safe to say a golden age of visualization ensued.","ref":"readme.html#acknowledgements","title":"GGity - Acknowledgements","type":"extras"},{"doc":"The package can be installed by adding ggity to your list of dependencies in mix.exs:def deps do [ {:ggity, &quot;~&gt; 0.3.0&quot;} ] endGGity requires Elixir 1.10, and will likely require Elixir 1.11 shortly after that version is released, due to the nice improvements in each version associated with handling dates and datetimes.Documentation can be generated with ExDoc.","ref":"readme.html#installation","title":"GGity - Installation","type":"extras"},{"doc":"Roadmap","ref":"roadmap.html","title":"Roadmap","type":"extras"},{"doc":"Support attaching custom attributes to plot elementsAdd other non-fillable shapes to shapes paletteAdd fillable shapes to shapes paletteBoxplotsGeneral annotation drawing","ref":"roadmap.html#v0-4","title":"Roadmap - v0.4","type":"extras"},{"doc":"FacetingHistogramsContinuous color scale (including legends)","ref":"roadmap.html#v0-5","title":"Roadmap - v0.5","type":"extras"},{"doc":"Implement a method for rendering new points and updating scales only (LiveView optimization)Draw legend on any side of the plot (top/left/bottom/right)Implement x_lim/y_limggplot2-ify gridlines approach (breaks, minor breaks)stat_smoothDensity plots/stats","ref":"roadmap.html#later","title":"Roadmap - Later","type":"extras"}]